//---------------------------------------------------------------------------
// Copyright (C) 1997-2008 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMdllClass
//
// Description:
//
// Implementation
//
// Author: Steven Dodd
// Date:   Jan 19, 2009
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2009-01-28 22:04:09 $
// Source: $Source: /home/cvs/cvsroot/CHM/CHMdllClass.cpp,v $
//---------------------------------------------------------------------------
#include "CHMpreCompHead.h"
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#  include <CHM/CHMdll.h>
#  include <CHM/CHMdllClass.h>
#  include <CHM/CHMerrorClass.h>
#endif

CHMdll::CHMdll()
:
   DllHandle( 0 )
{
   CHM_CHECK_CALL(CHMdllCreate( &DllHandle ));
}

CHMdll::~CHMdll()
{
   try
   {
      CHM_CHECK_CALL( CHMdllRelease(DllHandle) );
   }
   catch (...)
   {
   }
}

void CHMdll::loadLibrary(const CHMstring& DllFileName, CHMboolean IsOwner)
{
   CHM_CHECK_CALL(CHMdllLoadLibrary(DllHandle, DllFileName.c_str(), IsOwner));
}

void CHMdll::freeLibrary()
{
   CHM_CHECK_CALL(CHMdllFreeLibrary(DllHandle));
}

void* CHMdll::getProcAddress(const char* ProcName)
{
   void * ProcAddress = 0;
   CHM_CHECK_CALL(CHMdllGetProcAddress(DllHandle, ProcName, &ProcAddress));
   return ProcAddress;
}

CHMstring CHMdll::libraryName() const
{
   const CHMchar * LibraryName = 0;
   CHM_CHECK_CALL(CHMdllGetLibraryName(DllHandle,&LibraryName));
   return LibraryName;
}
